## fortran-jonquil 0.3.0

=== CMakeLists.txt ===
# This file is part of jonquil.
# SPDX-Identifier: Apache-2.0 OR MIT
#
# Licensed under either of Apache License, Version 2.0 or MIT license
# at your option; you may not use this file except in compliance with
# the License.
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

cmake_minimum_required(VERSION 3.9)
get_directory_property(is-subproject PARENT_DIRECTORY)

project(
  "jonquil"
  LANGUAGES "Fortran"
  VERSION "0.3.0"
  DESCRIPTION "Bringing TOML blooms to JSON land"
)

# Follow GNU conventions for installing directories
include(GNUInstallDirs)

# General configuration information
add_subdirectory("config")

# Collect subprojects
if(NOT TARGET "test-drive::test-drive" AND ENABLE_TESTING)
  find_package("test-drive" REQUIRED)
endif()
if(NOT TARGET "toml-f::toml-f")
  find_package("toml-f" REQUIRED)
endif()

# Collect source of the project
set(srcs)
add_subdirectory("src")

# TOML-Fortran library target
add_library(
  "${PROJECT_NAME}-lib"
  "${srcs}"
)
target_link_libraries(
  "${PROJECT_NAME}-lib"
  PUBLIC
  "toml-f::toml-f"
)
set_target_properties(
  "${PROJECT_NAME}-lib"
  PROPERTIES
  POSITION_INDEPENDENT_CODE TRUE
  OUTPUT_NAME "${PROJECT_NAME}"
  VERSION "${PROJECT_VERSION}"
  SOVERSION "${PROJECT_VERSION_MAJOR}"
  Fortran_MODULE_DIRECTORY "${PROJECT_BINARY_DIR}/include"
)
target_include_directories(
  "${PROJECT_NAME}-lib"
  PUBLIC
  $<BUILD_INTERFACE:${PROJECT_BINARY_DIR}/include>
  $<INSTALL_INTERFACE:${CMAKE_INSTALL_INCLUDEDIR}>
  $<INSTALL_INTERFACE:${CMAKE_INSTALL_INCLUDEDIR}/${module-dir}>
)
if(NOT EXISTS "${PROJECT_BINARY_DIR}/include")
  make_directory("${PROJECT_BINARY_DIR}/include")
endif()

# Export targets for other projects
add_library("${PROJECT_NAME}" INTERFACE)
target_link_libraries("${PROJECT_NAME}" INTERFACE "${PROJECT_NAME}-lib")
install(
  TARGETS
  "${PROJECT_NAME}"
  "${PROJECT_NAME}-lib"
  EXPORT
  "${PROJECT_NAME}-targets"
  LIBRARY DESTINATION "${CMAKE_INSTALL_LIBDIR}"
  ARCHIVE DESTINATION "${CMAKE_INSTALL_LIBDIR}"
)
install(
  EXPORT
  "${PROJECT_NAME}-targets"
  NAMESPACE
  "${PROJECT_NAME}::"
  DESTINATION "${CMAKE_INSTALL_LIBDIR}/cmake/${PROJECT_NAME}"
)
install(
  DIRECTORY
  "${PROJECT_BINARY_DIR}/include/"
  DESTINATION "${CMAKE_INSTALL_INCLUDEDIR}/${module-dir}"
)
# Package license files
install(
  FILES
  "LICENSE-Apache"
  "LICENSE-MIT"
  DESTINATION "${CMAKE_INSTALL_DATADIR}/licenses/${PROJECT_NAME}"
)

if(ENABLE_TESTING)
  # add the testsuite
  enable_testing()
  add_subdirectory("test")
endif()

=== config/CMakeLists.txt ===
# This file is part of jonquil.
# SPDX-Identifier: Apache-2.0 OR MIT
#
# Licensed under either of Apache License, Version 2.0 or MIT license
# at your option; you may not use this file except in compliance with
# the License.
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

option(BUILD_SHARED_LIBS "Whether the libraries built should be shared" FALSE)
option(ENABLE_TESTING "Whether the libraries built should be tested" TRUE)

set(
  "${PROJECT_NAME}-module-dir"
  "${PROJECT_NAME}/modules"
  CACHE STRING
  "Subdirectory to install generated module files to"
)
set(
  module-dir
  "${${PROJECT_NAME}-module-dir}"
)
set(module-dir "${module-dir}" PARENT_SCOPE)

# Set build type as CMake does not provide defaults
if(NOT CMAKE_BUILD_TYPE AND NOT CMAKE_CONFIGURATION_TYPES)
  set(
    CMAKE_BUILD_TYPE "RelWithDebInfo"
    CACHE STRING "Build type to be used."
    FORCE
  )
  message(
    STATUS
    "Setting build type to '${CMAKE_BUILD_TYPE}' as none was specified."
  )
endif()

list(APPEND CMAKE_MODULE_PATH "${CMAKE_CURRENT_SOURCE_DIR}/cmake")
set(CMAKE_MODULE_PATH "${CMAKE_MODULE_PATH}" PARENT_SCOPE)
install(
  DIRECTORY
  "${CMAKE_CURRENT_SOURCE_DIR}/cmake/"
  DESTINATION "${CMAKE_INSTALL_LIBDIR}/cmake/${PROJECT_NAME}"
)

include(CMakePackageConfigHelpers)
configure_package_config_file(
  "${CMAKE_CURRENT_SOURCE_DIR}/template.cmake"
  "${CMAKE_CURRENT_BINARY_DIR}/${PROJECT_NAME}-config.cmake"
  INSTALL_DESTINATION "${CMAKE_INSTALL_LIBDIR}/cmake/${PROJECT_NAME}"
)
write_basic_package_version_file(
  "${CMAKE_CURRENT_BINARY_DIR}/${PROJECT_NAME}-config-version.cmake"
  VERSION "${PROJECT_VERSION}"
  COMPATIBILITY SameMinorVersion
)
install(
  FILES
  "${CMAKE_CURRENT_BINARY_DIR}/${PROJECT_NAME}-config.cmake"
  "${CMAKE_CURRENT_BINARY_DIR}/${PROJECT_NAME}-config-version.cmake"
  DESTINATION "${CMAKE_INSTALL_LIBDIR}/cmake/${PROJECT_NAME}"
)

configure_file(
  "${CMAKE_CURRENT_SOURCE_DIR}/template.pc"
  "${CMAKE_CURRENT_BINARY_DIR}/${PROJECT_NAME}.pc"
  @ONLY
)
install(
  FILES
  "${CMAKE_CURRENT_BINARY_DIR}/${PROJECT_NAME}.pc"
  DESTINATION "${CMAKE_INSTALL_LIBDIR}/pkgconfig"
)

=== src/CMakeLists.txt ===
# This file is part of jonquil.
# SPDX-Identifier: Apache-2.0 OR MIT
#
# Licensed under either of Apache License, Version 2.0 or MIT license
# at your option; you may not use this file except in compliance with
# the License.
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

add_subdirectory("jonquil")

set(dir "${CMAKE_CURRENT_SOURCE_DIR}")

list(
  APPEND srcs
  "${dir}/jonquil.f90"
)

set(srcs "${srcs}" PARENT_SCOPE)

=== test/CMakeLists.txt ===
# This file is part of jonquil.
# SPDX-Identifier: Apache-2.0 OR MIT
#
# Licensed under either of Apache License, Version 2.0 or MIT license
# at your option; you may not use this file except in compliance with
# the License.
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

add_subdirectory("unit")

=== src/jonquil/CMakeLists.txt ===
# This file is part of jonquil.
# SPDX-Identifier: Apache-2.0 OR MIT
#
# Licensed under either of Apache License, Version 2.0 or MIT license
# at your option; you may not use this file except in compliance with
# the License.
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

set(dir "${CMAKE_CURRENT_SOURCE_DIR}")

list(
  APPEND srcs
  "${dir}/lexer.f90"
  "${dir}/parser.f90"
  "${dir}/ser.f90"
  "${dir}/version.f90"
)

set(srcs "${srcs}" PARENT_SCOPE)

=== test/unit/CMakeLists.txt ===
# This file is part of jonquil.
# SPDX-Identifier: Apache-2.0 OR MIT
#
# Licensed under either of Apache License, Version 2.0 or MIT license
# at your option; you may not use this file except in compliance with
# the License.
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

if(NOT TARGET "test-drive::test-drive")
  find_package("test-drive")
endif()

set(
  test-srcs
  "main.f90"
  "test_lexer.f90"
)

add_executable(
  "${PROJECT_NAME}-tester"
  "${test-srcs}"
)
target_link_libraries(
  "${PROJECT_NAME}-tester"
  PRIVATE
  "${PROJECT_NAME}-lib"
  "test-drive::test-drive"
)
add_test(
  "${PROJECT_NAME}/test"
  "${PROJECT_NAME}-tester"
)

=== debian/changelog ===
fortran-jonquil (0.3.0-4) unstable; urgency=medium

  * Move dh-fortran-mod -> dh-fortran
  * d/watch: Move to version 5 syntax
  * Standards-Version: 4.7.3
  * Drop Priority: optional from source in d/control per new policy
  * Add Section: needed for dh-fortran autodetection
  * Update pkgconf.patch; hard-coding no longer needed

 -- Alastair McKinstry <mckinstry@debian.org>  Tue, 06 Jan 2026 16:39:22 +0000

fortran-jonquil (0.3.0-3) unstable; urgency=medium

  * Changes needed for new dh_fortran_lib. Closes: #1120499

 -- Alastair McKinstry <mckinstry@debian.org>  Tue, 11 Nov 2025 13:49:21 +0000

fortran-jonquil (0.3.0-2) unstable; urgency=medium

  * Add debian/watch file
  * libfortran-jonquil-0 is multi-arch: same
  * Build-dep on libfortran-toml-dev, pkgconf
  * Add pkgconfig.patch to fix paths

 -- Alastair McKinstry <mckinstry@debian.org>  Fri, 19 Sep 2025 08:14:45 +0100

fortran-jonquil (0.3.0-1) experimental; urgency=medium

  * Initial release. (Closes: #1111619))

 -- Alastair McKinstry <mckinstry@debian.org>  Wed, 20 Aug 2025 09:21:46 +0100

=== debian/control ===
Source: fortran-jonquil
Section: utils
Maintainer: Debian Science Maintainers <debian-science-maintainers@lists.alioth.debian.org>
Standards-Version: 4.7.3
Uploaders: Alastair McKinstry <mckinstry@debian.org>
Build-Depends: debhelper-compat (= 13),
 dh-fortran,
 libfortran-testdrive-dev,
 libfortran-toml-dev,
 pkgconf,
 meson
Homepage: https://github.com/toml-f/jonquil
Vcs-Browser: https://salsa.debian.org/science-team/fortran-jonquil
Vcs-Git: https://salsa.debian.org/science-team/fortran-jonquil.git -b debian/latest

Package: libfortran-jonquil-dev
Architecture: any
Section: libdevel
Depends: ${misc:Depends},${fortran:Depends},
 libfortran-jonquil-0 ( = ${binary:Version})
Recommends: pkgconf
Description: Fortran library to add TOML features to JSON - devel files
 Jonquil (named after the flower) brings all the features available for
 TOML to JSON land. In fact it provides a seamless intercompatibility when
 working with the data structures of either library and allows to mix and
 match them freely.
 One key strength of Jonquil is that the data structures are not using any
 pointer components,but only allocatables, making them safe to work with,
 easy to (deep-)copy and simple to delete without special care or extra
 finalization.

Package: libfortran-jonquil-0
Architecture: any
Multi-Arch: same
Section: libs
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: Fortran library to add TOML features to JSON 
 Jonquil (named after the flower) brings all the features available for
 TOML to JSON land. In fact it provides a seamless intercompatibility when
 working with the data structures of either library and allows to mix and
 match them freely.
 One key strength of Jonquil is that the data structures are not using any
 pointer components,but only allocatables, making them safe to work with,
 easy to (deep-)copy and simple to delete without special care or extra
 finalization.

=== debian/rules ===
#!/usr/bin/make -f

export DH_VERBOSE=1

FMODDIR:=$(shell dh_fortran get_fmoddir)
FLIBDIR:=$(shell dh_fortran get_flibdir)

include /usr/share/dpkg/architecture.mk
PKGFILE=debian/tmp/usr/lib/$(DEB_HOST_MULTIARCH)/pkgconfig/jonquil.pc

# The magic debhelper  rule
%:
	dh $@ --with fortran


override_dh_auto_clean:
	rm -rf build subprojects/test-drive subprojects/toml-f

override_dh_auto_configure:
	meson setup build --prefix=$(CURDIR)/debian/tmp/usr

override_dh_auto_build:
	meson compile -C build	

override_dh_auto_test:
	@echo Bypass tests this build. require downloads

override_dh_auto_install:
	meson install -C build
	sed -i -e 's%@FMODDIR@%${FMODDIR}%' $(PKGFILE)
	sed -i -e 's%@FLIBDIR@%${FLIBDIR}%' $(PKGFILE)
	sed -i -e 's%{libdir}%{flibdir}%' $(PKGFILE)
	sed -i -e 's%{includedir}%{fmoddir}%g' $(PKGFILE)

=== debian/watch ===
Version: 5
Template: GitHub
Dist: https://github.com/toml-f/jonquil
